#!/usr/bin/perl

# This is the directory where the class creation files are stored
@files = </acfs/fall-2011/*>;

# loop through each file in the directory
# file is the variable holding the working file
foreach $file (@files) 
{
	
	# open the currernt file (cfile)
	open(cfile, "<$file");
	
	# prime the loop with variable declarations
	# and reinitiate them with each new file
	# the variables are set to fail to distinguish that the initialization
	# loop failed
	$semester = "fail";
	$class = "fail";
	$section = "fail";
	$instructor = "fail";
	
	# read the current file until end of stream (end of while loop)
	# the file is read one line at a time
	# this pass through the file handles creation of the variables
	# for semester, class, section, and instructor
	while(<cfile>) 
	{
		
		# remove the newlines from each line
		chomp;
		
		# Rational Expressions are being used and implying the $_
		# If the line contains Class: assign the class name to 
		# $class
		# Class is the value after Class:
		if (/class/) {
			
			# Class: has 6 characters, we want the $class variable
			# to have only the class value, so we assign every charcter
			# after the first 6 to $class
			# $_ is the temporary loop variable
			$class = substr($_, 6);
			print "$class\n";

		} # end of if (/class/)
		
		# Rational Expressions are being used and implying the $_
		# If the line contains Instructor: assign the instructors name
		# to $instructor
		# Name is the value after the colon in Instructor:
		if (/Instructor/) {

			# Instructor: has 11 characters, we want the $instructor variable
			# to have only the instructors Active Directory name, so we assign
			# every character after the first 11 to $instructor
			# $_ is the temporary loop variable
			$instructor = substr($_, 11);
			print "$instructor\n";

		} # end of if(/instructor/)
		
	} # end of while (<cfile>) used to read the contents of each file
	
	# close the current file
	close ($file);

} # end of foreach file (@files) that reads each file in semester directory

