#!/usr/bin/perl

# This is the directory where the class creation files are stored
@files = </Create-Accounts/Name-Files/*>;			

# Add groups for the instructors and students
system("groupadd studentsgroup");
system("groupadd instructorsgroup");

# loop through each file in the directory
# file is the variable holding the working file

foreach $file (@files) 
{
	# open the current file (cfile)
	open(cfile, "<$file");
		
	# Initiate variables with each new file
	# variables are initialized to fail to distinguish read failures
	$readline = "fail";						# The current line being read
	$semester = "fail";						# The semester classes are being created for	
	$class = "fail";							# The class accounts are being created for
	$section = "fail";						# The section number pertaining to class 
	$password = "fail";						# The password for each student
	@instructors = ();						# The instructors for the class 
	@students = ();							# The students for the class 	
	@studentspw = ();						# The students password for the student

	# read the current file until end of stream (end of while loop)
	# the file is read one line at a time
	# fill in the values of each variable to be used later

	while(<cfile>) 
	{
		# Reset $readline to blank
		$readline = "";		
		
		# Good practice to store $_ value because subsequent operations may change it
		$readline = $_;
		
		# remove the newlines from each line
		chomp($readline);
		#Begin an array to put the data from the csv file into
		my @elements = split "," , $readline;

		#if semester is found in the array add the data as semester
		if ($elements[$i] eq "semester")
		{
			$semester = $elements[1];
			print("$semester \n");
		}

		#if class is found in the array add the data as class
   	if ($elements[$i] eq "class")
		{
      	$class = $elements[1];
      	print("$class \n");
		}

		#if section is found in the array add the data as section
   	if ($elements[$i] eq "section")
		{
      	$section = $elements[1];
      	print("$section \n");
		}

		# if student is found in the array add the data for them to two new arrays, one for passwords and another for the names
   	if ($elements[$i] eq "student")
		{
      	print("student data is being added to an array  \n");
			push(@students, $elements[1]);
			push(@studentpw, $elements[2]);
		}

		# if instructor is found in the array add the data for them to two new arrays, one for passwords and another for the names
   	if ($elements[$i] eq "instructor")
		{
      	print("instructor data is being added to an array \n");
	 		push(@instructors, $elements[1]);
			push(@instructorpw, $elements[2]);
		}

} # end of while (<cfile>) used to read the contents of each file
	
	# Foreach loop to create the user, directories for them and symbolic link in var/www
	foreach $instructor (@instructors)
	{
     	print("$instructor user is being added and directories created \n");

		$password = $instructorpw[$n];

		# Create an instructor account	
		# Create a group that corresponds to student 		
		system("useradd -p $password -G instructorsgroup $instructor");	
		# Make the instructor directory under /home/{$instructor}
		# Change the owner of the directory to the instructor and the group that
		# corresponds to the instructor
		# Change the permissions on the directory to Read, Write, Execute
		# for the instructor and instructor group (including instructor) '77' from '770'
		# 'Everyone' does not have permissions on the instructor folder '0' from '770'

		system("mkdir /home/$instructor");
		system("chown -R $instructor:webservices /home/$instructor");
		system("chmod 770 -R /home/$instructor");

		# Make the instructor directory under /home/{$instructor}/{$semester}
		# Change the owner of the directory to the instructor and the group that
		# corresponds to the instructor
		# Change the permissions on the directory to Read, Write, Execute
		# for the instructor and instructor group (including instructor) '77' from '770'
		# 'Everyone' does not have permissions on the instructor folder '0' from '770'
		system("mkdir /home/$instructor/$semester");
		system("chown -R $instructor:webservices /home/$instructor/$semester");
		system("chmod 770 -R /home/$instructor/$semester");

		# Make the instructor directory under /home/{$instructor}/{$semester}/{$class}
		# Change the owner of the directory to the instructor and the group that
		# corresponds to the instructor
		# Change the permissions on the directory to Read, Write, Execute
		# for the instructor and instructor group (including instructor) '77' from '770'
		# 'Everyone' does not have permissions on the instructor folder '0' from '770'
		system("mkdir /home/$instructor/$semester/$class");
		system("chown -R $instructor:webservices /home/$instructor/$semester/$class");
		system("chmod 770 -R /home/$instructor/$semester/$class");

		# Make the instructor directory under /home/{$instructor}/{$semester}/{$class}/{$section}
		# Change the owner of the directory to the instructor and the group that
		# corresponds to the instructor
		# Change the permissions on the directory to Read, Write, Execute
		# For the instructor and instructor group (including instructor) '77' from '770'
		# 'Everyone' does not have permissions on the instructor folder '0' from '770'
		system("mkdir /home/$instructor/$semester/$class/$section");
		system("chown -R $instructor:webservices /home/$instructor/$semester/$class/$section");
		system("chmod 770 -R /home/$instructor/$semester/$class/$section");
	
		# Make a symbolic link under /var/www that points to the instructors home folder /home/{$instructor}
		system("ln -s /home/$instructor /var/www/$instructor");
		system("chown -R $instructor:webservices /var/www/$instructor");
		system("chmod 770 -R /var/www/$instructor");
		
		

		$n++;

}
	# Foreach loop to create the user, directories for them and symbolic link in var/www
	foreach $student (@students)
	{
     	print("$student user is being added and directories created \n");

		# Create a student account
		# Create a group that corresponds to student 		
		$password = $studentpw[$s];
		system("useradd -p $password -g studentsgroup $student");
	
		# Make the student directory under /home/{studentID}
		# Change the owner of the directory to the student and the group that
		# corresponds to the student
		# Change the permissions on the directory to Read, Write, Execute
		# for the student and student group (including instructor) '77' from '770'
		# 'Everyone' does not have permissions on the student folder '0' from '770'
		system("mkdir /home/$student");
		system("chown -R $student:webservices /home/$student");
		system("chmod 770 -R /home/$student");

		# Make the student directory under /home/{$student}/{$semester}
		# Change the owner of the directory to the student and the group that
		# corresponds to the student
		# Change the permissions on the directory to Read, Write, Execute
		# for the student and student group (including instructor) '77' from '770'
		# 'Everyone' does not have permissions on the student folder '0' from '770'
		system("mkdir /home/$student/$semester");
		system("chown -R $student:webservices /home/$student/$semester");
		system("chmod 770 -R /home/$student/$semester");

		# Make the student directory under /home/{$student}/{$semester}/{$class}
		# Change the owner of the directory to the student and the group that
		# corresponds to the student -- updated to webservices
		# Change the permissions on the directory to Read, Write, Execute
		# for the student and student group (including instructor) '77' from '770'
		# 'Everyone' does not have permissions on the student folder '0' from '770'
		system("mkdir /home/$student/$semester/$class");

		# Copy a test HTML file from the home root to the students folder
		system("cp /home/test.html /home/$student/$semester/$class");

		
		#system("chown -R $student:webservices /home/$student/$semester/$class");
		#system("chmod 770 -R /home/$student/$semester/$class");

		system("chown -R $student:webservices /home/$student/$semester");
		system("chmod 770 -R /home/$student/$semester");

		# Make a symbolic link in the instructors /home/{$instructor}/${semester}/{$class}/{$section} folder
		# that points to the students /home/{$student}/{$semester}/{$class} folder and is named after
		# the student
		# Make a symbolic link in the /var/www folder that points to the students /home/{$student}
		system("ln -s /home/$student /var/www/$student");
		system("chown -R $student:webservices /var/www/$student");
		system("chmod 770 -R /var/www/$student");
		
		system("chown -v -R $student /home/$student");
		system("chgrp -R webservices /home/$student");
		system("chmod 770 -R /home/$student");

		
		
		foreach $instructor (@instructors)
	{
	
		# Make a symbolic link in the instructors /home/{$instructor}/${semester}/{$class}/{$section} folder
		#		that points to the students /home/{$student}/{$semester}/{$class} folder and is named after
		#		the student
		system("ln -s /home/$student/$semester/$class /home/$instructor/$semester/$class/$section/$student");
		
		# Add the instructor to the students group.
		#	webservices has access to all of the student accounts
		#system("usermod -G webservices,$student,$instructor");
	
	}
		$s++;
	}
	# close the current file
	close ($file);

} # end of foreach file (@files) that reads each file in semester directory
